﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using RapidWebDevSample;


namespace RapidWebDevSample.Common
{
    /// <summary>
    /// 导航菜单构造器
    /// </summary>
    public class FunctionMenu
    {
        /// <summary>
        /// 支持两层
        /// </summary>
        /// <returns></returns>
        public static List<MenuItem> GetFunctionMenus()
        {
            List<MenuItem> items = new List<MenuItem>();
            using (RapidWebDevSampleEntities bse = new RapidWebDevSampleEntities())
            {
              
                //加载第一层
                List<T_FunctionType> list = bse.T_FunctionType.Where(p => p.ParentFunctionTypeID == 0 && p.Visible == 1).OrderBy(f => f.Index).ToList();
                //加载所有
                List<T_FunctionType> all = bse.T_FunctionType.Where(p => p.Visible == 1).OrderBy(f => f.Index).ToList();

                //循环加载第一层
                foreach (var functionType in list)
                {
                    MenuItem mi = new MenuItem()
                                  {icon = functionType.IconStyle, menuid = functionType.FunctionTypeID, menuname = functionType.FunctionTypeName, url = functionType.Url};

                        //从all中加载自己的子菜单
                        List<T_FunctionType> subs = all.Where(p => p.ParentFunctionTypeID == mi.menuid).OrderBy(f => f.Index).ToList();

                        //如果有
                        if (subs.Any())
                        {
                            List<MenuItem> subitems = new List<MenuItem>();
                            //循环添加子菜单
                            foreach (var subtype in subs)
                            {
                                MenuItem submi = new MenuItem() {icon = subtype.IconStyle, menuid = subtype.FunctionTypeID, menuname = subtype.FunctionTypeName, url = subtype.Url};

                                subitems.Add(submi);
                            }
                            mi.menus = subitems;
                        }
                        items.Add(mi);
                       
                    }
                
            }

            return items;
        }
    }
}
